unit uRegistrymanager;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, uCommands, ImgList, Buttons, Menus, uRegAdd;

type
  TForm5 = class(TForm)
    lvKeys: TListView;
    lvValues: TListView;
    edtPath: TEdit;
    cbb1: TComboBox;
    stat1: TStatusBar;
    il1: TImageList;
    btn1: TBitBtn;
    pm1: TPopupMenu;
    DeleteItem1: TMenuItem;
    NewItem1: TMenuItem;
    pm2: TPopupMenu;
    New1: TMenuItem;
    Rename1: TMenuItem;
    Delete1: TMenuItem;
    Refresh1: TMenuItem;
    N1: TMenuItem;
    procedure cbb1Select(Sender: TObject);
    procedure lvKeysDblClick(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure NewItem1Click(Sender: TObject);
    procedure DeleteItem1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
  private
    { Private declarations }
  public
    sSocket:Integer
    { Public declarations }
  end;

var
  Form5: TForm5;

implementation

uses uMain;

{$R *.dfm}

function GetLastPath(strPath:String):String;
begin
  Result := '';
  Delete(strPath,Length(strPath),1);
  strPath := ExtractFilePath(strPath);
  Result := StrPath;
end;

procedure TForm5.btn1Click(Sender: TObject);
begin
  if (edtPath.Text = 'HKEY_CLASSES_ROOT\') or (edtPath.Text = 'HKEY_CURRENT_USER\') or (edtPath.Text = 'HKEY_LOCAL_MACHINE\') or (edtPath.Text = 'HKEY_USERS\') or (edtPath.Text = 'HKEY_CURRENT_CONFIG\') then exit;
  edtPath.Text := GetLastPath(edtPath.Text);
  lvKeys.Clear;
  lvValues.Clear;
  if edtPath.Text <> '' then begin
    If SendPacket(sSocket,PACK_ENUMKEYS,Form1.edtPassword.text,edtPath.Text) then begin
      Stat1.Panels.Items[0].Text := 'Requesting keys...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request keys!';
    end;
  end;
end;

procedure TForm5.cbb1Select(Sender: TObject);
var
  sPath:String;
begin
  sPath := cbb1.Text + '\';
  if sPath <> '' then begin
    lvValues.Clear;
    lvKeys.Clear;
    edtPath.Text := sPath;
    If SendPacket(sSocket,PACK_ENUMKEYS,Form1.edtPassword.text,edtPath.Text) then begin
      Stat1.Panels.Items[0].Text := 'Requesting keys...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request keys!';
    end;
  end;
end;

procedure TForm5.Delete1Click(Sender: TObject);
begin
  if lvKeys.Selected = nil then exit;
  if edtPath.Text <> '' then begin
    If SendPacket(sSocket,PACK_REGDELETE,Form1.edtPassword.text,edtPath.Text + lvKeys.Selected.Caption + '\') then begin
      Stat1.Panels.Items[0].Text := 'Deleting keys...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant delete keys!';
    end;
  end;
end;

procedure TForm5.DeleteItem1Click(Sender: TObject);
begin
  if lvValues.Selected = nil then exit;
  if edtPath.Text <> '' then begin
    If SendPacket(sSocket,PACK_REGDELETE,Form1.edtPassword.text,edtPath.Text + lvValues.Selected.Caption) then begin
      Stat1.Panels.Items[0].Text := 'Deleting value...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant delete value!';
    end;
  end;
end;

procedure TForm5.lvKeysDblClick(Sender: TObject);
begin
  if lvKeys.Selected = nil then exit;
  edtPath.Text := edtPath.Text + lvKeys.Selected.Caption + '\';
  lvKeys.Clear;
  lvValues.Clear;
  if edtPath.Text <> '' then begin
    If SendPacket(sSocket,PACK_ENUMKEYS,Form1.edtPassword.text,edtPath.Text) then begin
      Stat1.Panels.Items[0].Text := 'Requesting keys...';
    end else begin
      Stat1.Panels.Items[0].Text := 'Error! Cant request keys!';
    end;
  end;
end;

procedure TForm5.New1Click(Sender: TObject);
var
  strVal:String;
begin
  if edtPath.Text <> '' then begin
    strVal := InputBox('New Registrykey','Registry Key','Default');
    if strVal <> '' then begin
      If SendPacket(sSocket,PACK_REGADD,Form1.edtPassword.text,'|' + edtPath.Text + strVal + '|Key|') then begin
        Stat1.Panels.Items[0].Text := 'Adding new key...';
      end else begin
        Stat1.Panels.Items[0].Text := 'Error! Cant add new key!';
      end;
    end;
  end;
end;

procedure TForm5.NewItem1Click(Sender: TObject);
var
  tempForm:TForm8;
begin
  if edtPath.Text <> '' then begin
    tempForm := TForm8.Create(nil);
    tempForm.sSocket := sSocket;
    tempForm.sPath := edtPath.Text;
    tempForm.Show;
  end;
end;

procedure TForm5.Refresh1Click(Sender: TObject);
begin
  if edtPath.Text <> '' then begin
    lvKeys.Clear;
    lvValues.Clear;
    if edtPath.Text <> '' then begin
      If SendPacket(sSocket,PACK_ENUMKEYS,Form1.edtPassword.text,edtPath.Text) then begin
        Stat1.Panels.Items[0].Text := 'Requesting keys...';
      end else begin
        Stat1.Panels.Items[0].Text := 'Error! Cant request keys!';
      end;
    end;
  end;
end;

procedure TForm5.Rename1Click(Sender: TObject);
var
  strVal:String;
begin
  if lvKeys.Selected = nil then exit;
  if edtPath.Text <> '' then begin
    strVal := InputBox('Rename Registrykey','Registry Key','Default');
    if strVal <> '' then begin
      If SendPacket(sSocket,PACK_REGRENAME,Form1.edtPassword.text,'|' + edtPath.Text + lvKeys.Selected.Caption + '|' + edtPath.Text + strVal) then begin
        Stat1.Panels.Items[0].Text := 'Renaming key...';
      end else begin
        Stat1.Panels.Items[0].Text := 'Error! Cant rename key!';
      end;
    end;
  end;
end;

end.
