unit uVNC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, ImgList, ToolWin, Menus, ScktComp, uCommands,
  winsock;

type
  TForm4 = class(TForm)
    img1: TImage;
    il1: TImageList;
    stat1: TStatusBar;
    pb1: TProgressBar;
    tlb1: TToolBar;
    btn1: TToolButton;
    procedure btn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RequestImage;
    procedure RequestNextImage;
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    sSocket:Integer;
    sVNCSocket:Integer;
    hHeight, hWidth, hRatio:Integer;
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

uses uMain,
  uFunctions;

{$R *.dfm}
procedure TForm4.RequestNextImage;
var
  sTempStr:String;
begin
  if btn1.Down then begin
    pb1.Position := 0;
    sTempStr := IntToStr(hRatio);
    If SendPacket(sVNCSocket,PACK_VNCDATA,Form1.edtPassword.text,sTempStr) then
      Stat1.Panels.Items[0].Text := 'VNC Activated!'
    else
      Stat1.Panels.Items[0].Text := 'Socket Error!';
  end;
end;

procedure TForm4.RequestImage;
var
  sTempStr:String;
begin
  if btn1.Down then begin
    pb1.Position := 0;
    Self.BorderStyle := bsSIngle;
    sTempStr := IntToStr(hRatio);
    If SendPacket(sVNCSocket,PACK_STARTVNC,Form1.edtPassword.text,sTempStr) then
      Stat1.Panels.Items[0].Text := 'VNC Activated!'
    else
      Stat1.Panels.Items[0].Text := 'Socket Error!';
  end else
    Self.BorderStyle := bsSizeable;
end;

procedure TForm4.btn1Click(Sender: TObject);
begin
  RequestImage;
end;

procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if btn1.Down then
    btn1.Down := False;
end;

procedure TForm4.FormResize(Sender: TObject);
var
  eRatio:extended;
begin
  if ((hWidth <> 0) and (hHeight <> 0)) then begin
    eRatio := hWidth / hHeight;
    Width := Trunc(Img1.Height * eRatio);
    eRatio :=  ((img1.height) /hheight );
    hRatio := Trunc(eRatio * 100);
  end;
end;

procedure TForm4.FormShow(Sender: TObject);
var
  sTempStr:String;
  mList:TList;
  tTrans: TSocketInfo;
begin
  // ---------Button----------------
  btn1.Enabled := False;
  if sVNCSocket <> 0 then begin
    btn1.Enabled := True;
    exit;
  end;
  sTempStr := '|' + Inttostr(sSocket);
  tTrans := TSocketInfo.Create;
  tTrans.fVNC := Self;
  tTrans.lSocketID := sSocket;
  tTrans.lTransferID := 0;
  try
    mList := Form1.VNCList.LockList;
    mList.Add(tTrans);
  finally
    Form1.TransferList.UnlockList;
  end;
  If SendPacket(sSocket,PACK_REQUESTVNC,Form1.edtPassword.text,sTempStr) then begin
    Stat1.Panels.Items[0].Text := 'Requesting VNC-Socket...';
  end else begin
    Stat1.Panels.Items[0].Text := 'Socket Error!';
  end;
end;

end.
