unit uScreenshot;
interface
uses windows,uFunctions, compressionStreamUnit;
function GetSymetrics:String;
function SaveBitmapToString(hBitmap: HBITMAP; BitCount: Word;
  var sBuffer: String): Cardinal;
function CaptureWND(hWindow:HWND;Ratio:Extended;var x,y:integer):HBITMAP;
procedure CompareStream(MyFirstStream,MySecondStream,MyCompareStream:TMemoryStream);
implementation

function SaveBitmapToString(hBitmap: HBITMAP; BitCount: Word;
  var sBuffer: String): Cardinal;
const
  BM_TYPE = $4D42;
function AlignDouble(Size: Longint): Longint;
begin
  Result := (Size + 31) div 32 * 4;
end;
var
  BitmapStruct: BITMAP;
  BitmapHeader: TBitmapFileHeader;
  BitmapInfo: PBitmapInfo;
  DC: HDC;
  ColorSize, DataSize: Longint;
  BitBuffer: Pointer;
begin
  Result := 0;
  if (GetObject(hBitmap, SizeOf(BITMAP), @BitmapStruct) > 0) then
  try
    if (BitCount <> 24) then
    begin
      ColorSize := SizeOf(TRGBQuad) * (1 shl BitCount);
    end else
    begin
      ColorSize := 0;
    end;
    DataSize :=
      AlignDouble(BitmapStruct.bmWidth * BitCount) * BitmapStruct.bmHeight;
    GetMem(BitmapInfo, SizeOf(TBitmapInfoHeader) + ColorSize);
    if Assigned(BitmapInfo) then
    try
      with BitmapInfo^.bmiHeader do
      begin
        biSize := SizeOf(TBitmapInfoHeader);
        biWidth := BitmapStruct.bmWidth;
        biHeight := BitmapStruct.bmHeight;
        biPlanes := 1;
        biBitCount := BitCount;
        biCompression := 0;
        biSizeImage := DataSize;
        biXPelsPerMeter := 0;
        biYPelsPerMeter := 0;
        biClrUsed := 0;
        biClrImportant := 0;
      end;
      with BitmapHeader do
      begin
        bfOffBits := SizeOf(BitmapHeader) + SizeOf(TBitmapInfo) + ColorSize;
        bfReserved1 := 0;
        bfReserved2 := 0;
        bfSize := Longint(bfOffBits) + DataSize;
        bfType := BM_TYPE;
      end;
      GetMem(BitBuffer, DataSize);
      if Assigned(BitBuffer) then
      try
        DC := GetDC(0);
        try
          if (GetDIBits(DC, hBitmap, 0, BitmapStruct.bmHeight,
            BitBuffer, BitmapInfo^, DIB_RGB_COLORS) <> 0) then
          begin
            SetLength(sBuffer, SizeOf(BitmapHeader) + SizeOf(TBitmapInfo) +
              ColorSize + DataSize);
            CopyMemory(@sBuffer[1], @BitmapHeader, SizeOf(BitmapHeader));
            CopyMemory(@sBuffer[SizeOf(BitmapHeader) + 1],
              BitmapInfo, SizeOf(TBitmapInfo) + ColorSize);
            CopyMemory(@sBuffer[SizeOf(BitmapHeader) +
              SizeOf(TBitmapInfo) + ColorSize + 1], BitBuffer, DataSize);
            Result := SizeOf(BitmapHeader) + SizeOf(TBitmapInfo) +
              ColorSize + DataSize;
          end;
        finally
          ReleaseDC(0, DC);
        end;
      finally
        FreeMem(BitBuffer);
      end;
    finally
      FreeMem(BitmapInfo);
    end;
  finally
    DeleteObject(hBitmap);
  end;
end;

function CaptureWND(hWindow:HWND;Ratio:Extended;var x,y:integer):HBITMAP;
var  BmpInfo:BITMAPINFO; DC1,DC2:hDC; p:Pointer;  old:hgdiobj;
begin
    if hWindow = 0 then hWindow := GetDesktopWindow();
    DC1 := GetDC(hWindow);
    x := GetDeviceCaps(DC1,HORZRES);
    y := GetDeviceCaps(DC1,VERTRES);
    ZeroMemory(@BmpInfo.bmiHeader, sizeof(BITMAPINFOHEADER));
    BmpInfo.bmiHeader.biWidth := round(x * RATIO);
    BmpInfo.bmiHeader.biHeight := round(y * RATIO);
    BmpInfo.bmiHeader.biPlanes := 1;
    BmpInfo.bmiHeader.biBitCount := 32;
    BmpInfo.bmiHeader.biSize := sizeof(BITMAPINFOHEADER);
    DC2 := CreateCompatibleDC(0);
    Result := CreateDIBSection(DC2,BmpInfo, DIB_RGB_COLORS,p, 0, 0);
    Old := SelectObject(DC2, Result);
    if(RATIO <> 1)then
     begin
        SetStretchBltMode(DC2, HALFTONE); SetBrushOrgEx(DC2, 0, 0, nil);
        StretchBlt(DC2, 0, 0, BmpInfo.bmiHeader.biWidth, BmpInfo.bmiHeader.biHeight, DC1, 0, 0, x, y, SRCCOPY);
     end
    else BitBlt(DC2, 0, 0, BmpInfo.bmiHeader.biWidth, BmpInfo.bmiHeader.biHeight, DC1, 0, 0, SRCCOPY);
    SelectObject(DC2,Old);
    DeleteDC(DC2); ReleaseDC(hWindow, DC1);
    x := BmpInfo.bmiHeader.biWidth;
    y := BmpInfo.bmiHeader.biHeight;
end;

function GetSymetrics:String;
begin
  Result := IntToStr(GetSystemMetrics(SM_CXSCREEN)) + '|' + IntToStr(GetSystemMetrics(SM_CYSCREEN));
end;

procedure CompareStream(MyFirstStream,MySecondStream,MyCompareStream:TMemoryStream);
var
  I: Integer;
  P1, P2, P3: ^Char;
begin
  P1 := MyFirstStream.Memory;
  P2 := MySecondStream.Memory;
  MyCompareStream.Write(P1^, myFirstStream.Size);
  P3 := MyCompareStream.Memory;
  for I := 0 to MyFirstStream.Size - 1 do
  begin
    if P1^ = P2^ then
      P3^ := '0'
    else
      P3^ := P2^;
    Inc(P1);
    Inc(P2);
    Inc(P3);
  end;
end;


end.
